/*
	NSURL+Etoile.h
	
	Description forthcoming.
 
	Copyright (C) 2008 Quentin Mathe
 
	Author:  Quentin Mathe <qmathe@club-internet.fr>
	Date:  March 2008
 
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:

	* Redistributions of source code must retain the above copyright notice,
	  this list of conditions and the following disclaimer.
	* Redistributions in binary form must reproduce the above copyright notice,
	  this list of conditions and the following disclaimer in the documentation
	  and/or other materials provided with the distribution.
	* Neither the name of the Etoile project nor the names of its contributors
	  may be used to endorse or promote products derived from this software
	  without specific prior written permission.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
	LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
	CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
	THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <EtoileFoundation/NSURL+Etoile.h>
#import <EtoileFoundation/NSString+Etoile.h>


@implementation NSURL (Etoile)

/** Returns a new URL instance by stripping the last path component of the 
	receiver. */
- (NSURL *) parentURL
{
	return [NSURL fileURLWithPath: [[self path] stringByDeletingLastPathComponent]];
}

/** Returns the last path component of the path portion of the receiver. */
- (NSString *) lastPathComponent
{
	return [[self path] lastPathComponent];
}

/** Returns a new URL instance with aPath appended to the part partion of the 
	receiver. */
- (NSURL *) URLByAppendingPath: (NSString *)aPath
{
	return [NSURL fileURLWithPath: [[self path] stringByAppendingPathComponent: aPath]];
}

/* Deprecated */

/** Deprecated... Do not use.
	Returns a new URL instance with aPath appended to the part partion of the 
	receiver. */
- (NSURL *) appendPath: (NSString *)aPath
{
	return [self URLByAppendingPath: aPath];
}

@end
